/*
 * Copyright (c) 2000, 2001 University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of Clack.
 * 
 * Clack is free software, also known as "open source."  You can redistribute
 * it and/or modify it under the terms of the GNU General Public License
 * (GPL), version 2, as published by the Free Software Foundation (FSF).
 * 
 * Clack is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GPL for more details.  You should have
 * received a copy of the GPL along with Clack; see the file COPYING.  If
 * not, write to the FSF, 59 Temple Place #330, Boston, MA 02111-1307, USA.
 * 
 * Clack is modelled on and includes some code fragments from MIT's Click
 * system (http://www.pdos.lcs.mit.edu/click/) which is copyright (c)
 * 1999-2000 Massachusetts Institute of Technology and also GPL'ed.
 * 
 * Users are requested, but not required, to send to csl-dist@cs.utah.edu any
 * improvements that they make and grant Univ. of Utah redistribution rights.
 */

#ifndef _CLACK_TYPES_H_
#define _CLACK_TYPES_H_

#ifdef OSKIT
/*
 * Map OSKIT types to Clack types.
 */
#include <oskit/machine/types.h>
#include <oskit/error.h>

typedef oskit_error_t		clack_error_t;
typedef oskit_size_t		clack_size_t;
typedef oskit_u8_t		clack_u8_t;
typedef oskit_u16_t		clack_u16_t;
typedef oskit_u32_t		clack_u32_t;
typedef oskit_u64_t		clack_u64_t;

#else
/*
 * Make up Clack types.
 */
#include <sys/types.h>
/*
 * See cdefs.h. Doesn't work.
 */
#undef  __unused
#define __unused __unused

typedef int			clack_error_t;
typedef size_t			clack_size_t;
typedef u_char			clack_u8_t;
typedef u_short			clack_u16_t;
typedef u_int			clack_u32_t;
typedef u_quad_t		clack_u64_t;

#endif

#endif /* _CLACK_TYPES_H_ */
